<template>
  <div>
    <v-form ref="form" v-model="valid" lazy-validation @submit="handleSignUp">
      <v-container>
        <v-card class="mx-auto" max-width="600">
          <v-card-text>
            <p class="display-1 text--primary">ลงทะเบียนเป็น Partner</p>
            <p>กรุณากรอกรายละเอียด</p>
            <InputRegisterForm
              :firstname.sync="obj.firstname"
              :lastname.sync="obj.lastname"
              :type.sync="obj.type"
              :email.sync="obj.email"
              :telNo.sync="obj.telNo"
              :password.sync="obj.password"
              :cPassword.sync="obj.cPassword"
              :address.sync="obj.address"
              :id_card.sync="obj.id_card"
              :id_cardNiti.sync="obj.id_cardNiti"
            />
            <div class="my-1">
              <v-btn
                type="submit"
                :loading="loading"
                :disabled="loading"
                color="info"
                depressed
                block
                medium
                >ลงทะเบียน</v-btn
              >
            </div>
          </v-card-text>
        </v-card>
      </v-container>
    </v-form>
  </div>
</template>

<script>
import InputRegisterForm from "./InputRegisterForm";
export default {
  data() {
    return {
      valid: true,
      obj: {},
      loading: false,
    };
  },
  components: {
    InputRegisterForm,
  },
  methods: {
    async handleSignUp(e) {
      e.preventDefault();

      const formValid = this.$refs.form.validate();
      if (formValid === true) {
        this.loading = true;
        let param = {
          Email: this.obj.email,
          Password: this.obj.password,
          FirstName: this.obj.firstname,
          LastName: this.obj.lastname,
          IdCard: "1234567890123",
          RoleUser: "Partner",
          PartnerAddress: this.obj.address,
          PartnerType: this.obj.type,
          TelNo: this.obj.telNo,
          PartnerNumber:
            this.obj.id_card == undefined ||
            this.obj.id_card == null ||
            this.obj.id_card == ""
              ? this.obj.id_cardNiti
              : this.obj.id_card,
        };
        await this.$store.dispatch("auth/register", param);
        const valid = await this.$store.getters["auth/result"];
        if (valid == true) {
          this.obj = {};
          this.loading = false;
          this.$router.push({
            path: `/register-message`,
            query: {
              payload: {
                title: "สมัครสมาชิกสำเร็จ",
                body: "รอการตรวจสอบจาก ผู้ดูเเล",
              },
            },
          });
          await this.$store.dispatch("snackbar/showSnack", {
            text: "สมัครสมาชิกสำเร็จรอการตรวจสอบจาก ผู้ดูเเล",
            color: "success",
            timeout: 3000,
          });
        } else {
          this.$router.push({
            path: `/register-message`,
            query: {
              payload: {
                title: "สมัครสมาชิกไม่สำเร็จ",
                body: "การสมัครสมาชิกเกิดข้อผิดพลาด",
              },
            },
          });
          await this.$store.dispatch("snackbar/showSnack", {
            text: "การสมัครสมาชิกเกิดข้อผิดพลาด",
            color: "success",
            timeout: 3000,
          });
          this.loading = false;
        }
      }
    },
  },
};
</script>

<style>
</style>